routes/web.php
<?php

use App\Http\Controllers\DepartemenController;
use App\Http\Controllers\JabatanController;
use App\Http\Controllers\JamKerjaController;
use App\Http\Controllers\LiburnasController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/hashpassword', function () {
    print_r(Hash::make('Secret123!@#'));
    die();
    // return ;
});

Route::get('/hashingpassword', function () {
    return Hash::make('test123');
});

Auth::routes();


Route::group(['middleware' => ['auth']], function(){
    Route::get('/absensi/absensi-hari-ini/AbsenHariIni', 'App\Http\Controllers\Absensi\AbsensiHariIniController@absenHariIni')->name('absen.absen-hari-ini');
    //Dashboard
    Route::get('/', [App\Http\Controllers\DashboardController::class, 'index'])->name('home');
    //AUTH
    Route::get('logout', '\App\Http\Controllers\Auth\LoginController@logout');
    //Jam Lembur
    Route::get('/JamJembur/pengajuan-lembur/{id}/create', 'App\Http\Controllers\PengajuanLemburController@create')->name('Lembur.create');
    
    //Absensi
    Route::get('/absensi/absensi-hari-ini/index', 'App\Http\Controllers\Absensi\AbsensiHariIniController@index')->name('Absen.index');
    Route::get('/absensi/absensi-hari-ini/{id}/show', 'App\Http\Controllers\Absensi\AbsensiHariIniController@show')->name('Absen.show');
    Route::post('/absensi/absensi-hari-ini/filter_by_month', 'App\Http\Controllers\Absensi\AbsensiHariIniController@filter_by_month')->name('Absen.filter-by-month');
    Route::get('/absensi/absensi-hari-ini/show_old', 'App\Http\Controllers\Absensi\AbsensiHariIniController@rv')->name('Absen.show-old');
    Route::get('/absensi/absensi-hari-ini/show_ol', 'App\Http\Controllers\Absensi\AbsensiHariIniController@show_old')->name('absen.absen-hari-ini-ol');
    Route::get('/absensi/absensi-hari-ini/exportExcelAll', 'App\Http\Controllers\Absensi\AbsensiHariIniController@exportExcelAll')->name('Absen.export-excel-all');
    Route::get('/absensi/absensi-hari-ini/exportExcelUser', 'App\Http\Controllers\Absensi\AbsensiHariIniController@exportExcelUser')->name('Absen.export-excel-user');
    //Holiday
    Route::get('/absensi/absensi-hari-ini/getHolidays', 'App\Http\Controllers\Absensi\AbsensiHariIniController@getHolidays')->name('Absen.get-holidays');
    
    //Report
    Route::get('/absensi/report-absensi/index', 'App\Http\Controllers\Absensi\ReportAbsensiController@index')->name('Report.index');
    Route::post('/absensi/report-absensi/exportReport', 'App\Http\Controllers\Absensi\ReportAbsensiController@exportReport')->name('Report.export-report');
    Route::post('/absensi/report-absensi/importReport', 'App\Http\Controllers\Absensi\ReportAbsensiController@importReport')->name('Report.import-report');
    Route::post('/absensi/report-absensi/getDownload', 'App\Http\Controllers\Absensi\ReportAbsensiController@getDownload')->name('Report.get-download');

    //Master User
    Route::resource('/MasterUser', App\Http\Controllers\MasterUserController::class);
    Route::get('/MasterUser/PengaturanAkun/{id}', 'App\Http\Controllers\MasterUserController@pengaturanAkun')->name('MasterUser.pengaturan-akun');
    Route::get('/MasterUser/PengaturanPengguna/{id}', 'App\Http\Controllers\MasterUserController@pengaturanPengguna')->name('MasterUser.pengaturan-pengguna');
    Route::post('/MasterUser/updatePengaturanPengguna', 'App\Http\Controllers\MasterUserController@updatePengaturanPengguna')->name('MasterUser.update-pengaturan-pengguna');
    Route::post('/MasterUser/gantiFoto', 'App\Http\Controllers\MasterUserController@gantiFoto')->name('MasterUser.ganti-foto');
    Route::get('/MasterUser/changePassword/{id}', 'App\Http\Controllers\MasterUserController@changePassword')->name('MasterUser.change-password');
    Route::post('/MasterUser/updatePassword', 'App\Http\Controllers\MasterUserController@updatePassword')->name('MasterUser.update-password');

    //Liburnas
    Route::resource('/Liburnas', App\Http\Controllers\LiburnasController::class);
    Route::post('Liburnas/store-liburnas-from-website', [LiburnasController::class, 'storeLiburnasFromWebsite'])->name('Liburnas.storeLiburnasFromWebsite');
    Route::post('Liburnas/update-libur', [LiburnasController::class, 'updateLibur'])->name('Liburnas.updateLibur');
    Route::delete('Liburnas/{id_liburnas}/delete', [LiburnasController::class, 'delete']);


    //Jam Kerja
    Route::resource('/JamKerja', App\Http\Controllers\JamKerjaController::class);
    Route::post('JamKerja/update-jam', [JamKerjaController::class, 'updateJam'])->name('Jam.updateJam');
    
    //DEPARTEMEN
    Route::resource('/Departemen', App\Http\Controllers\DepartemenController::class);
    Route::delete('departemen/{id_departemen}/delete', [DepartemenController::class, 'delete']);
    Route::post('departemen/update-departemen', [DepartemenController::class, 'updateDepartemen'])->name('Departemen.updateDepartemen');
    
    //JABATAN
    Route::resource('/Jabatan', App\Http\Controllers\JabatanController::class);
    Route::delete('jabatan/{id_jabatan}/delete', [JabatanController::class, 'delete']);
    Route::post('jabatan/update-jabatan', [JabatanController::class, 'updateJabatan'])->name('Jabatan.updateJabatan');
});

app/Http/Controllers/MasterUserController.php
<?php

namespace App\Http\Controllers;

use App\Models\TMbiodata;
use App\Models\TMdepartemen;
use App\Models\TMjabatan;
use Illuminate\Http\Request;
use App\Models\User;
use App\Models\TMrole;
use App\Models\TMupah;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Validator;
use stdClass;

class MasterUserController extends Controller
{
    public function index()
    {
        $role = TMrole::get();
        $users = User::select('users.*', 'tm_role.role')
                    ->join('tm_role', 'users.role_id', '=', 'tm_role.id')
                    ->get();
        $jabatan = TMjabatan::select('tm_jabatan.*', 'tm_departemen.departemen')->join('tm_departemen', 'tm_departemen.id', 'tm_jabatan.departemen_id')->orderBy('departemen_id', 'ASC')->get();
        $departemen = TMdepartemen::get();
        $upah = TMupah::get();
        return view('master_user.index', compact('users', 'role', 'jabatan', 'departemen', 'upah'));
    }

    public function create()
    {
        return view('master_user.create');
    }

    public function store(Request $request)
    {
        
        // dd($request->role);
        $response = array(
            'status' => 'failed'
        );
        $validated = Validator::make($request->all(),[
            'email' => 'required|email|unique:users',
            'nama' => 'required',
            'name' => 'required',
            'password' => 'required|min:5',
            'role' => 'required',
            'departemen' => 'required',
            'upah' => 'required',
            'nik' => 'required',
            'npwp' => 'required',
            'tmk' => 'required',
            'no_telepon' => 'required',
            'jenis_kelamin' => 'required',
            'tempat_lahir' => 'required',
            'tanggal_lahir' => 'required',
            'alamat' => 'required',
            'agama' => 'required',
        ],[
            'email.required' => 'Harap isi bidang Email',
            'email.email' => 'Email tidak valid',
            'email.unique' => 'Email Sudah Ada',
            'nama.required' => 'Harap isi bidang Nama Lengkap',
            'name.required' => 'Harap isi bidang Username',
            'password.required' => 'Harap isi bidang Password',
            'password.min' => 'Password minimal 3',
            'role.required' => 'Harap isi bidang Peran/Role',
            'departemen.required' => 'Harap isi bidang Departemen',
            'upah.required' => 'Harap memilih bidang Upah',
            'nik.required' => 'Harap isi bidang NIK',
            'npwp.required' => 'Harap isi bidang NPWP',
            'tmk.required' => 'Harap isi bidang Tanggal Masuk Kerja',
            'no_telepon.required' => 'Harap isi bidang Nomor Telepon',
            'tempat_lahir.required' => 'Harap isi bidang Tempat Lahir',
            'tanggal_lahir.required' => 'Harap isi bidang Tanggal Lahir',
            'alamat.required' => 'Harap isi bidang Alamat',
            'agama.required' => 'Harap isi bidang Agama',
        ]);
        if ($validated->fails())
        {
            return response()->json(['errors'=>$validated->errors()->all()]);
        }
        // dd($request->jenis_kelamin);
        if ($validated) {
            $insert = User::create([
                'nama' => $request->nama,
                'username' => $request->name,
                'email' => $request->email,
                'password' => Hash::make($request->password),
                'role_id' => $request->role,
                'status' => ($request->status == 'on') ? 1 : 0,
            ]);
            $last_inserted_id = User::latest()->first()->id;
            $insert_biodata = TMbiodata::create([
                'user_id' => $last_inserted_id,
                'jabatan_id' => $request->departemen,
                'upah_id' => $request->upah,
                'nik' => $request->nik,
                'npwp' => $request->npwp,
                'tmk' => $request->tmk,
                'no_telepon' => $request->no_telepon,
                'jenis_kelamin' => $request->jenis_kelamin,
                'tempat_lahir' => $request->tempat_lahir,
                'tanggal_lahir' => $request->tanggal_lahir,
                'alamat' => $request->alamat,
                'agama' => $request->agama,
            ]);
            
            if($insert_biodata){
                if ($insert) {
                    $response = array(
                        'status' => 'success'
                    );
                }else{
                    $response = array(
                        'status' => 'failed'
                    );
                }
            }else {
                $response = array(
                    'status' => 'failed'
                );
            }
        }
        echo json_encode($response);
    }

    public function show($id)
    {

        $user = User::select('users.*', 'tm_biodata.user_id', 'tm_biodata.jabatan_id', 'tm_biodata.nik','tm_biodata.npwp', 'tm_biodata.no_telepon', 'tm_biodata.jenis_kelamin', 'tm_biodata.tempat_lahir', 'tm_biodata.tanggal_lahir', 'tm_biodata.alamat', 'tm_biodata.agama', 'tm_biodata.status_perkawinan', 'tm_jabatan.departemen_id','tm_jabatan.jabatan', 'tm_departemen.departemen', 'tm_upah.upah')
        ->join('tm_biodata', 'users.id', '=', 'tm_biodata.user_id')
        ->join('tm_jabatan', 'tm_biodata.jabatan_id', '=', 'tm_jabatan.id')
        ->join('tm_departemen', 'tm_jabatan.departemen_id', '=', 'tm_departemen.id')
        ->join('tm_upah', 'tm_biodata.upah_id', '=', 'tm_upah.id')
        ->where('users.id', $id)
        ->first();
        
        return view('master_user.show', compact('user'));
    }

    public function delete($id)
    {
        $deleteUser =  User::find($id)->delete($id);
        

        return response()->json(['message' => 'Record deleted successfully!']);
    }

    public function pengaturanAkun($id)
    {
        // $user = User::select('users.*', 'tm_biodata.user_id', 'tm_biodata.jabatan_id', 'tm_biodata.departemen_id', 'tm_biodata.no_telepon', 'tm_biodata.jenis_kelamin', 'tm_biodata.tempat_lahir', 'tm_biodata.tanggal_lahir', 'tm_biodata.alamat', 'tm_biodata.agama', 'tm_jabatan.jabatan', 'tm_departemen.departemen')
        // ->join('tm_biodata', 'users.id', '=', 'tm_biodata.user_id')
        // ->join('tm_jabatan', 'tm_biodata.jabatan_id', '=', 'tm_jabatan.id')
        // ->join('tm_departemen', 'tm_biodata.departemen_id', '=', 'tm_departemen.id')
        // ->where('users.id', $id)
        // ->first();
        // $jabatan =  $role = TMjabatan::get();
        // $departemen =  $role = TMdepartemen::get();

        // return view('master_user.pengaturan_akun', compact('user', 'jabatan', 'departemen'));
    }

    

    public function pengaturanPengguna($id)
    {
        $user = User::select('users.*', 'tm_biodata.id as biodata_id', 'tm_biodata.user_id', 'tm_biodata.jabatan_id', 'tm_biodata.upah_id', 'tm_biodata.npwp', 'tm_biodata.nik', 'tm_biodata.tmk', 'tm_biodata.no_telepon', 'tm_biodata.jenis_kelamin', 'tm_biodata.tempat_lahir', 'tm_biodata.tanggal_lahir', 'tm_biodata.status_perkawinan', 'tm_biodata.alamat', 'tm_biodata.agama', 'tm_jabatan.departemen_id', 'tm_jabatan.jabatan', 'tm_departemen.departemen', 'tm_upah.upah')
        ->join('tm_biodata', 'users.id', '=', 'tm_biodata.user_id')
        ->join('tm_jabatan', 'tm_biodata.jabatan_id', '=', 'tm_jabatan.id')
        ->join('tm_departemen', 'tm_jabatan.departemen_id', '=', 'tm_departemen.id')
        ->join('tm_upah', 'tm_biodata.upah_id', '=', 'tm_upah.id')
        ->where('users.id', $id)
        ->first();
        
        $jabatan =  TMjabatan::get();
        $departemen =  TMdepartemen::get();
        $upah =  TMupah::get();
        
        return view('master_user.pengaturan_pengguna', compact('user', 'jabatan', 'departemen', 'upah'));
    }

    public function updatePengaturanPengguna(Request $request)
    {
        // dd($request->oldPhoto);
        // return $request->file('photo')->store('post-images');
        $user = User::where('id', $request['user_id'])->first();
        if ($user) {
            if ($request->file('photo')) {
                
                if ($request->has('nama') && $request->has('username') ) {
                    if ($request->oldPhoto) {
                        Storage::delete('public/'.$request->oldPhoto);
                    }
                    $updateUser = User::find($request->user_id);
                    $updateUser->nama=$request['nama'];
                    $updateUser->username=$request['username'];
                    $updateUser->photo=$request->file('photo')->store('post-images', 'public');
                    $updateUser->save();
                }
                $updateBiodata = TMbiodata::find($request->biodata_id);
                $updateBiodata->jabatan_id=$request['jabatan'];
                $updateBiodata->upah_id=$request['upah'];
                $updateBiodata->no_telepon=$request['no_telepon'];
                $updateBiodata->tanggal_lahir=$request['tanggal_lahir'];
                $updateBiodata->tempat_lahir=$request['tempat_lahir'];
                $updateBiodata->jenis_kelamin=$request['jenis_kelamin'];
                $updateBiodata->alamat=$request['alamat'];
                $updateBiodata->status_perkawinan=$request['status_perkawinan'];
                $updateBiodata->tmk=$request['tmk'];
                $updateBiodata->nik=$request['nik'];
                $updateBiodata->save();
            }else {
                if ($request->has('nama') && $request->has('username') ) {
                    $updateUser = User::find($request->user_id);
                    $updateUser->nama=$request['nama'];
                    $updateUser->username=$request['username'];
                    $updateUser->save();
                }
                $updateBiodata = TMbiodata::find($request->biodata_id);
                $updateBiodata->jabatan_id=$request['jabatan'];

resources/views/master_user/change_password.blade.php
@extends('layouts.main')

@section('content')
<div class="grid grid-cols-12 gap-6 mt-5">
    <div class="col-span-12 lg:col-span-4 2xl:col-span-3 flex lg:block flex-col-reverse">
        <div class="intro-y box mt-5 lg:mt-0">
            <div class="relative flex items-center p-5">
                <div class="w-12 h-12 image-fit">
                    <img alt="Midone - HTML Admin Template" class="rounded-full" src="{{ url('assets/dist/images/profile-1.jpg') }}">
                </div>
                <div class="ml-4 mr-auto">
                    <div class="font-medium text-base">{{ $user->nama }}</div>
                    <div class="text-slate-500">{{ ($user->jabatan) ? $user->jabatan : "-"  }}</div>
                </div>
            </div>
            <div class="p-5 border-t border-slate-200/60 dark:border-darkmode-400">
                <a class="flex items-center" href="{{ route('MasterUser.show', $user->id) }}"> <i data-lucide="activity" class="w-4 h-4 mr-2"></i> Info Pengguna </a>
                <a class="flex items-center mt-5" href=""> <i data-lucide="box" class="w-4 h-4 mr-2"></i> Pengaturan Akun </a>
                <a class="flex items-center mt-5 text-primary font-medium" href="{{ route('MasterUser.change-password', $user->id) }}"> <i data-lucide="lock" class="w-4 h-4 mr-2"></i> Ganti Password </a> 
                @if (auth()->user()->role_id == 1)
                <a class="flex items-center mt-5" href="{{ route('MasterUser.pengaturan-pengguna', $user->id) }}"> <i data-lucide="settings" class="w-4 h-4 mr-2"></i> Pengaturan Pengguna </a>
                @endif
            </div>
            <div class="p-5 border-t border-slate-200/60 dark:border-darkmode-400">
                <a class="flex items-center" href=""> <i data-lucide="activity" class="w-4 h-4 mr-2"></i> Pengaturan Email </a>
                <a class="flex items-center mt-5" href=""> <i data-lucide="box" class="w-4 h-4 mr-2"></i> Kartu Kredit Tersimpan </a>
                <a class="flex items-center mt-5" href=""> <i data-lucide="lock" class="w-4 h-4 mr-2"></i> Sosial Media </a>
                <a class="flex items-center mt-5" href=""> <i data-lucide="settings" class="w-4 h-4 mr-2"></i> Informasi Gaji </a>
            </div>
        </div>
    </div>
    <div class="col-span-12 lg:col-span-8 2xl:col-span-9">
        <div class="grid grid-cols-12 gap-6">
            <!-- BEGIN: Seller Details -->
            <div class="intro-y box col-span-12 2xl:col-span-6">
                <div class="box p-5 rounded-md">
                    <form id="form-data-user">
                        @csrf
                            <input type="hidden" id="user-id" value="{{ $user->id }}">
                            <label class="form-label required" for="password-existing">Kata sandi lama</label>
                            <input class="form-control" type="password" name="password_existing" id="password-existing" required>
                            @if ($errors->has('old_password'))
                            <span class="text-danger">{{ $errors->first('old_password') }}</span>
                            @endif
                            <label class="form-label required mt-5" for="new-password">Kata sandi baru</label>
                            <input class="form-control" type="password" name="new_password" id="new-password" required>

                            <label class="form-label required mt-5" for="confirmation-password">Konfirmasi kata sandi anda</label>
                            <input class="form-control" type="password" name="confirmation_password" id="confirmation-password" required>

                            <input type="checkbox" class="form-check-input" name="show_password" id="show-password">
                            <label class="form-label mt-5" for="show-password">Lihat kata sandi</label>
                        <div align="right">
                            <button type="button" class="btn btn-success btn-md" id="save-button"><i data-lucide="save" class="w-4 h-4 mr-1"></i>Simpan perubahan</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- BEGIN: Modal Failed Form Content -->
<div id="failed-modal-preview" class="modal" tabindex="-1" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body p-0">
                <div class="p-5 text-center"> <i data-lucide="x-octagon" class="w-16 h-16 text-danger mx-auto mt-3"></i>
                    <div class="text-3xl mt-5">Gagal Tersimpan!</div>
                    <div class="text-slate-500 mt-2">
                        <span id="spanFailed"></span>
                    </div>
                </div>
                <div class="px-5 pb-8 text-center"> <button type="button" data-tw-dismiss="modal" class="btn btn-primary w-24 ok-failed">Ok</button> </div>
            </div>
        </div>
    </div>
</div> 
<!-- END: Modal Failed Form Content -->

<!-- BEGIN: Modal Success Form Content -->
<div id="success-modal-preview" class="modal" tabindex="-1" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body p-0">
                <div class="p-5 text-center"> <i data-lucide="check-circle" class="w-16 h-16 text-success mx-auto mt-3"></i>
                    <div class="text-3xl mt-5">Data Tersimpan!</div>
                    <div class="text-slate-500 mt-2">
                        @if (session()->has('success'))
                        {{ session('success') }}
                        @endif
                    </div>
                </div>
                <div class="px-5 pb-8 text-center"> <a href="{{ route('home') }}"><button type="button" data-tw-dismiss="modal" class="btn btn-primary w-24 button-success">Ok</button></a> </div>
            </div>
        </div>
    </div>
</div> 
<!-- END: Modal Success Form Content -->
@endsection

@section('js')
<script>
    $('#show-password').click(function() {
        if ($('#show-password').is(':checked')) {
            $('#password-existing').attr('type', 'text');
            $('#new-password').attr('type', 'text');
            $('#confirmation-password').attr('type', 'text');
        } else {
            $('#password-existing').attr('type', 'password');
            $('#new-password').attr('type', 'password');
            $('#confirmation-password').attr('type', 'password');
        }
    })
</script>
<script>
    $('#button-success').click(function(e) {
        e.preventDefault();
        location.reload();
    });
    $('#save-button').click(function() {
        var data_user = {
            user_id: $('#user-id').val(),
            old_password: $('#password-existing').val(),
            new_password: $('#new-password').val(),
            confirmation_password: $('#confirmation-password').val(),
        };
        let token = $('input[name="_token"]').val();
        console.log(data_user, token);
        $.ajax({
            headers: {
                'X-CSRF-TOKEN': token
            },
            type: 'POST',
            url: "{{ route('MasterUser.update-password') }}",
            data: data_user,
            success: function(response) {
                console.log(response.status)
                console.log(response.message)
                var message = response.message;
                if (response.status == 'errors'){
                    $("#spanFailed").html(message);
                    const failedModal = tailwind.Modal.getInstance(document.querySelector("#failed-modal-preview"));
                    failedModal.show();
                }else{
                    const successModal = tailwind.Modal.getInstance(document.querySelector("#success-modal-preview"));
                    successModal.show().then(function() {
                            window.location.href = "{{ route('MasterUser.show', $user->id) }}";
                        });
                }

            },
            error: function(jqXHR, textStatus, errorThrown) {
                if (jqXHR.status == 422) {
                    var message = ''
                    for (var i in jqXHR.responseJSON.errors) {
                        var d = jqXHR.responseJSON.errors[i]

                        for (var f in d) {
                            message += d[f] + '<br>'
                        }
                    }
                    console.log(message)
                    $("#spanFailed").html(message);
                    const failedModal = tailwind.Modal.getInstance(document.querySelector("#failed-modal-preview"));
                    failedModal.show().then(function() {
                        location.reload();
                    });
                }
            }
        });
    })
</script>
@endsection